/**
	  Album Cover Grabber - Grabs album covers automatically off the internet
	  Copyright (C) 2002  Kevin M Schmidt

	  This program is free software; you can redistribute it and/or modify
	  it under the terms of the GNU General Public License as published by
	  the Free Software Foundation; either version 2 of the License, or
	  (at your option) any later version.

	  This program is distributed in the hope that it will be useful,
	  but WITHOUT ANY WARRANTY; without even the implied warranty of
	  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	  GNU General Public License for more details.

	  You should have received a copy of the GNU General Public License
	  along with this program; if not, write to the Free Software
	  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package com.bluedragontavern.albumgrabber.util;

/**
 * Used by the findBestMatchingOrder method to sort the indexs by their assigned scores
 */
public class IndexScore
	implements Comparable
{
	private Integer index;
	private Integer score;

	/**
	 * Constructor
	 */
	public IndexScore(int index, int score)
	{
		this.index = new Integer(index);
		this.score = new Integer(score);
	}

	/**
	 * Get index
	 */
	public int getIndex()
	{
		return index.intValue();
	}

	/**
	 * Get score
	 */
	public int getScore()
	{
		return score.intValue();
	}

	/**
	 * Compare method
	 */
	public int compareTo(Object o)
	{
		return score.compareTo( ( (IndexScore) o).score);
	}
}